Orgatron/Pages/Evenements/Create.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;
using Orgatron.Models;

namespace Orgatron.Pages.Evenements
{
    [Authorize(Policy = "AdminOnly")]
    public class CreateModel : PageModel
    {
        private readonly Orgatron.Models.OrgatronContext _context;
        private readonly UserManager<IdentityUser> _userManager;

        public CreateModel(Orgatron.Models.OrgatronContext context, UserManager<IdentityUser> userManager)
        {
            _context = context;
            _userManager = userManager;
        }

        public IActionResult OnGet()
        {
            return Page();
        }

        [BindProperty]
        public Evenement Evenement { get; set; }

        public async Task<IActionResult> OnPostAsync()
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }

            IdentityUser createur = await _userManager.FindByIdAsync(User.FindFirst(ClaimTypes.NameIdentifier).Value);

            Evenement.Createur = createur;

            _context.Evenement.Add(Evenement);

            await _context.SaveChangesAsync();

            return RedirectToPage("./Index");
        }
    }
}

Orgatron/Pages/Evenements/Delete.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Orgatron.Models;

namespace Orgatron.Pages.Evenements
{
    [Authorize(Policy = "AdminOnly")]
    public class DeleteModel : PageModel
    {
        private readonly Orgatron.Models.OrgatronContext _context;

        public DeleteModel(Orgatron.Models.OrgatronContext context)
        {
            _context = context;
        }

        [BindProperty]
        public Evenement Evenement { get; set; }

        public async Task<IActionResult> OnGetAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Evenement = await _context.Evenement.FirstOrDefaultAsync(m => m.Id == id);

            if (Evenement == null)
            {
                return NotFound();
            }
            return Page();
        }

        public async Task<IActionResult> OnPostAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Evenement = await _context.Evenement.FindAsync(id);

            if (Evenement != null)
            {
                _context.Evenement.Remove(Evenement);
                await _context.SaveChangesAsync();
            }

            return RedirectToPage("./Index");
        }
    }
}

Orgatron/Pages/Evenements/Invitation.cshtml.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text.Encodings.Web;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Identity.UI.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Orgatron.Models;

namespace Orgatron.Pages.Evenements
{
    public class InvitationModel : PageModel
    {

        private readonly IEmailSender _emailSender;
        private readonly IAuthorizationService _authorizationService;
        private readonly OrgatronContext _context;
        private readonly UserManager<IdentityUser> _userManager;

        public InvitationModel(
            OrgatronContext context,
            IAuthorizationService authorizationService,
            IEmailSender emailSender,
            UserManager<IdentityUser> userManager)
        {
                _emailSender = emailSender;
            _authorizationService = authorizationService;
            _context = context;
            _userManager = userManager;

        }
        
        public Evenement Evenement { get; set; }

        [BindProperty]
        public InputModel Input { get; set; }

        public class InputModel
        {
            [Required]
            [StringLength(100, ErrorMessage = "Le {0} doit y avoir au minimum {2} caractères et au maximum {1} caractères.", MinimumLength = 3)]
            public string Name { get; set; }

            [Required]
            [EmailAddress]
            public string Email { get; set; }
        }
        
        private async Task SendInscriptionMailAsync(IdentityUser user)
        {
            var code = await _userManager.GenerateEmailConfirmationTokenAsync(user);
            var callbackUrl = Url.Page(
                    "/Inscription",
                    pageHandler: null,
                    values: new { code, user.Email },
                    protocol: Request.Scheme);

            await _emailSender.SendEmailAsync(
                user.Email,
                "Inscription",
                $"Bonjour,<br/>" +
                $"Ceci est votre invitation à l'application Orgatron qui va gérer l'organisation des parties.<br/>" +
                $"Pour vous connectez, commencez par vous connecter au Wifi \"Durzooland\" à Charols et <a href='{HtmlEncoder.Default.Encode(callbackUrl)}'>cliquez sur ce lien </a>.<br/>" +
                $"<br/>" +
                $"A tout de suite :)<br/>" +
                $"Jules<br/>");
        }

        public async Task<IActionResult> OnGetAsync(int? id)
        {

            if (id == null)
            {
                return NotFound();
            }

            Evenement = _context.Evenement.Include(i => i.Createur).Include(i => i.EvenementsUtilisateurs).ThenInclude(eu => eu.User).SingleOrDefault(x => x.Id == id);

            // l'utilisateur est-il le créateur de l'évènement ?
            var isAuthorized = await _authorizationService.AuthorizeAsync(User, "AdminOnly");
            if (!isAuthorized.Succeeded)
            {
                if (User.Identity.IsAuthenticated)
                {
                    return new ForbidResult();
                }
                else
                {
                    return new ChallengeResult();
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostSendMailAsync(string email, int? id)
        {

            Evenement = _context.Evenement.Include(i => i.Createur).Include(i => i.EvenementsUtilisateurs).ThenInclude(eu => eu.User).SingleOrDefault(x => x.Id == id);
            var isAuthorized = await _authorizationService.AuthorizeAsync(User, "AdminOnly");
            if (!isAuthorized.Succeeded)
            {
                if (User.Identity.IsAuthenticated)
                {
                    return new ForbidResult();
                }
                else
                {
                    return new ChallengeResult();
                }
            }

            if (email == null)
            {
                ModelState.AddModelError(string.Empty, "Il faut choisir un utilisateur avec une adresse mail");
                return Page();
            }

            var user = await _userManager.FindByEmailAsync(Input.Email);
            await SendInscriptionMailAsync(user);

            return RedirectToPage("./Invitation", new { id });
        }

        public async Task<IActionResult> OnPostAsync(int? id)
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }

            Evenement = _context.Evenement.Include(i => i.Createur).Include(i => i.EvenementsUtilisateurs).ThenInclude(eu => eu.User).SingleOrDefault(x => x.Id == id);

            // l'utilisateur est-il le créateur de l'évènement ?
            var isAuthorized = await _authorizationService.AuthorizeAsync(User, "AdminOnly");
            if (!isAuthorized.Succeeded)
            {
                if (User.Identity.IsAuthenticated)
                {
                    return new ForbidResult();
                }
                else
                {
                    return new ChallengeResult();
                }
            }

            var user = await _userManager.FindByEmailAsync(Input.Email);
            if (user == null)
            {
                var userWithSameName = await _userManager.FindByNameAsync(Input.Name);
                if (userWithSameName != null)
                {
                    ModelState.AddModelError(string.Empty, "Un autre utilisateur utilise déjà ce nom");
                    return Page();
                }
                // On crée le user
                user = new IdentityUser(Input.Name)
                {
                    Email = Input.Email
                };
                await _userManager.CreateAsync(user);
                await _userManager.UpdateNormalizedEmailAsync(user);

                await SendInscriptionMailAsync(user);
            }

            EvenementUtilisateur evenementUtilisateur = Evenement.EvenementsUtilisateurs.Where(e => e.Evenement.Id == id && e.User.Id == user.Id).FirstOrDefault();

            if (evenementUtilisateur == null)
            {
                evenementUtilisateur = new EvenementUtilisateur
                {
                    User = user,
                    Evenement = Evenement
                };
                _context.EvenementUtilisateur.Add(evenementUtilisateur);
                _context.SaveChanges();
            }

            return RedirectToPage("./Invitation", new { id });
        }
    }
}

Orgatron/Pages/Evenements/Leaderboard.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Orgatron.Models;

namespace Orgatron.Pages.Evenements
{
    public class LeaderBoardModel : PageModel
    {
        private readonly Orgatron.Models.OrgatronContext _context;
        private readonly IAuthorizationService _authorizationService;

        public LeaderBoardModel(Orgatron.Models.OrgatronContext context, IAuthorizationService authorizationService)
        {
            _context = context;
            _authorizationService = authorizationService;
        }

        public string IdEvenement { get; set; }

        public List<DisplayModel> Classement { get;set; }

        public class DisplayModel
        {
            public string Joueur { get; set; }
            public int Score { get; set; }
            public double Moyenne { get; set; }
            public int NbParties { get; set; }
            public int NbRefus{ get; set; }
            public int MinutesPause { get; set; }
            public int AjustementModeration { get; set; }
        }

        [BindProperty]
        public InputModel Input { get; set; }
        public class InputModel
        {
            public int? EvenementId { get; set; }
            public string UserName { get; set; }
            public int Points { get; set; }
        }

        public async Task<IActionResult> OnGetAsync(int? idEvenement)
        {
            if (idEvenement == null)
            {
                Evenement evenement = _context.Evenement.Where(e => _context.EvenementUtilisateur.Where(eu => eu.Evenement == e && eu.User.Id == HttpContext.User.FindFirst(ClaimTypes.NameIdentifier).Value).Any()).OrderByDescending(e => e.StartedAt).FirstOrDefault();
                if (evenement == null)
                {
                    return NotFound();
                }
                idEvenement = evenement.Id;
            }

            IdEvenement = idEvenement.Value.ToString();

            //Participations
            List<Participant> participants = await _context.Participant.Include(p => p.User).Include(p => p.Partie).Where(p => p.Partie.Evenement.Id == idEvenement && p.Etat == EtatInvitation.Accepted && p.Partie.Etat == EtatPartie.Ended).ToListAsync();

            Dictionary<string, DisplayModel> keyValuePairs = new Dictionary<string, DisplayModel>();
            foreach (Participant participant in participants)
            {
                if (!keyValuePairs.ContainsKey(participant.User.UserName))
                {
                    keyValuePairs.Add(participant.User.UserName, new DisplayModel{ Joueur = participant.User.UserName, NbParties = 1, Score = participant.Points, Moyenne = (double)participant.Points });
                }
                else
                {
                    keyValuePairs[participant.User.UserName].Score += participant.Points;
                    keyValuePairs[participant.User.UserName].NbParties ++;
                }
            }

            //Malus refus
            List<Participant> refus = _context.Participant.Include(p => p.User).Include(p => p.Partie).Where(p => p.Partie.Evenement.Id == idEvenement && p.Etat == EtatInvitation.Rejected).ToList();
            foreach (Participant participant in refus)
            {
                if (!keyValuePairs.ContainsKey(participant.User.UserName))
                {
                    keyValuePairs.Add(participant.User.UserName, new DisplayModel { Joueur = participant.User.UserName, NbParties = 0, Score = 0, NbRefus = 1 });
                }
                else
                {
                    keyValuePairs[participant.User.UserName].NbRefus += 1;
                }
            }

            //Malus Pause et ajustement admins
            List<EvenementUtilisateur> pauses = _context.EvenementUtilisateur.Include(eu => eu.User).Where(p => p.Evenement.Id == idEvenement).ToList();
            foreach (EvenementUtilisateur participant in pauses)
            {
                //Ajustement arbitre
                if (!keyValuePairs.ContainsKey(participant.User.UserName))
                {
                    keyValuePairs.Add(participant.User.UserName, new DisplayModel { Joueur = participant.User.UserName, NbParties = 0, Score = 0, Moyenne = 0, NbRefus = 0, MinutesPause = 0, AjustementModeration = participant.ModificateurPoints });
                }
                else
                {
                    int nbRefus = keyValuePairs[participant.User.UserName].AjustementModeration = participant.ModificateurPoints;
                }
                //Malus pause
                if (participant.DateDebutPause != DateTime.MinValue)
                { 
                    int mn = (int)participant.NbSecondesPause;
                    if (participant.EstEnPause)
                    {
                        mn += (int)(new DateTime(Math.Min(DateTime.Now.Ticks,participant.Evenement.EndAt.Ticks)) - participant.DateDebutPause).TotalSeconds;
                    }
                    mn = mn / 60;
                    int nbRefus = keyValuePairs[participant.User.UserName].MinutesPause += mn;
                }
            }

            foreach (DisplayModel classement in keyValuePairs.Values)
            {
                int scoremodifie = classement.Score + classement.AjustementModeration;
                if (classement.NbRefus > 2)
                {
                    scoremodifie -= classement.NbRefus - 2;
                }
                if (classement.MinutesPause > 15)
                {
                    //On ne prend en compte que la partie entière de la division comme ce sont des int
                    scoremodifie -= (classement.MinutesPause)/15;
                }
                classement.Moyenne = (double)scoremodifie / (double)classement.NbParties;
            }
            
            Classement = keyValuePairs.Values.OrderByDescending(v => v.Moyenne).ToList();

            return Page();
        }

        public async Task<IActionResult> OnPostEditScoreAsync()
        {
            int? idEvenement = Input.EvenementId;
            if (idEvenement == null)
            {
                Evenement evenement = _context.Evenement.Where(e => _context.EvenementUtilisateur.Where(eu => eu.Evenement == e && eu.User.Id == HttpContext.User.FindFirst(ClaimTypes.NameIdentifier).Value).Any()).OrderByDescending(e => e.StartedAt).FirstOrDefault();
                if (evenement == null)
                {
                    return NotFound();
                }
                idEvenement = evenement.Id;
            }
            EvenementUtilisateur evenementUtilisateur = _context.EvenementUtilisateur.Where(eu => eu.User.UserName == Input.UserName && eu.Evenement.Id == idEvenement.Value).FirstOrDefault();

            if (evenementUtilisateur == null)
            {
                return NotFound();
            }

            var isAuthorized = await _authorizationService.AuthorizeAsync(User, "AdminOnly");
            if (!isAuthorized.Succeeded)
            {
                if (User.Identity.IsAuthenticated)
                {
                    return new ForbidResult();
                }
                else
                {
                    return new ChallengeResult();
                }
            }

            evenementUtilisateur.ModificateurPoints = Input.Points;

            _context.SaveChanges();

            return RedirectToPage("/Evenements/Leaderboard", new { idEvenement = Input.EvenementId });

        }
    }
}

Orgatron/Pages/Evenements/Create.cshtml
@page
@model Orgatron.Pages.Evenements.CreateModel

@{
	ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Evenement</h4>
<hr />
<div class="row">
	<div class="col-md-4">
		<form method="post">
			<div asp-validation-summary="ModelOnly" class="text-danger"></div>
			<div class="form-group">
				<label asp-for="Evenement.Nom" class="control-label"></label>
				<input asp-for="Evenement.Nom" class="form-control" />
				<span asp-validation-for="Evenement.Nom" class="text-danger"></span>
			</div>
			<div class="form-group">
				<label asp-for="Evenement.StartedAt" class="control-label"></label>
				<input asp-for="Evenement.StartedAt" class="form-control" id="datetimepicker_start" />
				<span asp-validation-for="Evenement.StartedAt" class="text-danger"></span>
			</div>
			<div class="form-group">
				<label asp-for="Evenement.EndAt" class="control-label"></label>
				<input asp-for="Evenement.EndAt" class="form-control" id="datetimepicker_end" />
				<span asp-validation-for="Evenement.EndAt" class="text-danger"></span>
			</div>
			<div class="form-group">
				<label asp-for="Evenement.NbPersonnesEnAttente" class="control-label"></label>
				<input asp-for="Evenement.NbPersonnesEnAttente" class="form-control" />
				<span asp-validation-for="Evenement.NbPersonnesEnAttente" class="text-danger"></span>
			</div>
			<div class="form-group">
				<input type="submit" value="Create" class="btn btn-primary" />
			</div>
		</form>
	</div>
</div>

<div>
	<a asp-page="Index">Back to List</a>
</div>

@section Scripts {
	@{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

Orgatron/Pages/Evenements/Delete.cshtml
@page
@model Orgatron.Pages.Evenements.DeleteModel

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Evenement</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.Nom)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.Nom)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.StartedAt)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.StartedAt)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.EndAt)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.EndAt)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.NbPersonnesEnAttente)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.NbPersonnesEnAttente)
        </dd>
    </dl>
    
    <form method="post">
        <input type="hidden" asp-for="Evenement.Id" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-page="./Index">Back to List</a>
    </form>
</div>

Orgatron/Pages/Evenements/DeleteInvitation.cshtml
@page
@model Orgatron.Pages.Evenements.DeleteInvitationModel
@{
    ViewData["Title"] = "DeleteInvitation";
}

<h1>DeleteInvitation</h1>

Orgatron/Pages/Evenements/Details.cshtml
@page
@model Orgatron.Pages.Evenements.DetailsModel

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Evenement</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.Nom)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.Nom)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.StartedAt)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.StartedAt)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.EndAt)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.EndAt)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Evenement.NbPersonnesEnAttente)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Evenement.NbPersonnesEnAttente)
        </dd>
    </dl>
</div>
<div>
    <a asp-page="./Edit" asp-route-id="@Model.Evenement.Id">Edit</a> |
    <a asp-page="./Index">Back to List</a>
</div>

Orgatron/Pages/Evenements/Index.cshtml
@page
@model Orgatron.Pages.Evenements.IndexModel

@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

<p>
    <a asp-page="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Evenement[0].Nom)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Evenement[0].StartedAt)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Evenement[0].EndAt)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Evenement[0].NbPersonnesEnAttente)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model.Evenement) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Nom)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.StartedAt)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.EndAt)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.NbPersonnesEnAttente)
            </td>
			<td>
				<a asp-page="./Start" asp-route-id="@item.Id">Démarrer la partie</a> |
				<a asp-page="./Invitation" asp-route-id="@item.Id">Inviter</a> |
				<a asp-page="./Edit" asp-route-id="@item.Id">Edit</a> |
				<a asp-page="./Details" asp-route-id="@item.Id">Details</a> |
				<a asp-page="./Delete" asp-route-id="@item.Id">Delete</a>
			</td>
        </tr>
}
    </tbody>
</table>

Orgatron/Pages/Evenements/Invitation.cshtml
@page
@model Orgatron.Pages.Evenements.InvitationModel
@{
	ViewData["Title"] = "Invitation";
	Layout = "~/Pages/Shared/_Layout.cshtml";
}

<h1>@ViewData["Title"]</h1>
<h4>Inviter un joueur</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form method="post">
            <div asp-validation-summary="All" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Input.Name"></label>
                <input asp-for="Input.Name" class="form-control" />
                <span asp-validation-for="Input.Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Input.Email"></label>
                <input asp-for="Input.Email" class="form-control" />
                <span asp-validation-for="Input.Email" class="text-danger"></span>
            </div>
            <button type="submit" class="btn btn-primary">Inviter</button>
        </form>
        <table class="table">
            <thead>
                <tr>
                    <th>
                        Nom d'utilisateur
                    </th>
                    <th>
                        Email
                    </th>
                    <th>
                        Supprimer
                    </th>
                    <th>
                        Pause
                    </th>
                    <th>
                        Moderateur
                    </th>
                    <th>
                        Reinit. Compte
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model.Evenement.EvenementsUtilisateurs)
                {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.User.UserName)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.User.Email)
                    </td>
                    <td>
                        @if (!item.User.EmailConfirmed)
                        {
                            <form asp-page-handler="sendmail" method="post" asp-route-id="@Model.Evenement.Id" asp-route-email="@item.User.Email">
                                <button class="btn btn-default">Renvoyer le mail</button>
                            </form>
                        }
                        <a asp-page="./DeleteInvitation" asp-route-id="@Model.Evenement.Id" asp-route-email="@item.User.Email">Supprimer</a>
                    </td>
                    <td>
                        @if (!item.EstEnPause)
                        {
                            <a asp-page="/Evenements/Pause" asp-route-IdEvenement="@Model.Evenement.Id" asp-route-playerName="@item.User.UserName" asp-route-value="true">Mettre en pause</a>
                        }
                        else
                        {
                            <a asp-page="/Evenements/Pause" asp-route-IdEvenement="@Model.Evenement.Id" asp-route-playerName="@item.User.UserName" asp-route-value="false">Remettre en jeu</a>
                        }
                    </td>
                    <td>
                        @if (!item.EstModerateur)
                        {
                            <a asp-page="/Evenements/Moderateur" asp-route-IdEvenement="@Model.Evenement.Id" asp-route-playerName="@item.User.UserName" asp-route-value="true">Passer Moderateur</a>
                        }
                        else
                        {
                            <a asp-page="/Evenements/Moderateur" asp-route-IdEvenement="@Model.Evenement.Id" asp-route-playerName="@item.User.UserName" asp-route-value="false">Remettre simple mortel</a>
                        }
                    </td>
                    <td>
                        <a asp-page="/Evenements/ReinitialiserCompte" asp-route-IdEvenement="@Model.Evenement.Id" asp-route-playerName="@item.User.UserName">supprimer MDP</a>
                    </td>
                </tr>
                }
            </tbody>
        </table>
    </div>
</div>

@section Scripts {
	<partial name="_ValidationScriptsPartial" />
}

Orgatron/Pages/Evenements/Leaderboard.cshtml
@page
@model Orgatron.Pages.Evenements.LeaderBoardModel

@{
	ViewData["Title"] = "Index";
}

<h1>Leaderboard</h1>

<div>Le meilleur joueur est celui qui a la meilleure moyenne de points par partie après application des bonus/malus</div>

<table class="table">
	<thead>
        <tr>
            <th>
                Classement
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Classement[0].Joueur)
            </th>
            <th>
                Moyenne
            </th>
            <th>
                Points
            </th>
            <th>
                Nb parties
            </th>
            <th>
                Nb refus
            </th>
            <th>
                Mn pause
            </th>
            <th>
                Ajustements
            </th>
            <th>
                Historique
            </th>
        </tr>
	</thead>
	<tbody>
		@{int i = 0;}
		@foreach (var item in Model.Classement)
		{
        <tr>
            <td>
                @{i++;}
                @i
            </td>
            <td>
                @Html.DisplayFor(model => item.Joueur)
            </td>
            <td>
                @item.Moyenne.ToString("0.##")
            </td>
            <td>
                @Html.DisplayFor(model => item.Score)
            </td>
            <td>
                @Html.DisplayFor(model => item.NbParties)
            </td>
            <td>
                @Html.DisplayFor(model => item.NbRefus)
            </td>
            <td>
                @Html.DisplayFor(model => item.MinutesPause)
            </td>
            @if ((await AuthorizationService.AuthorizeAsync(User, "AdminOnly")).Succeeded)
            {
                <td>
                    <form method="post" asp-page-handler="editScore" class="row">
                        <input type="hidden" asp-for="Input.UserName" value="@item.Joueur" />
                        <input type="hidden" asp-for="Input.EvenementId" value="@(Request.Query["idEvenement"])" />
                        <div class="col-sm-6">
                            <input asp-for="Input.Points" class="form-control" value="@item.AjustementModeration" />
                            <span asp-validation-for="Input.Points" class="text-danger"></span>
                        </div>
                        <div class="col-sm-6">
                            <button type="submit" class="btn btn-primary">Modifier</button>
                        </div>
                        <div class="col-sm-12 text-danger" asp-validation-summary="All"></div>
                    </form>
                </td>
            }
            else
            {
                <td>
                    @Html.DisplayFor(model => item.AjustementModeration)
                </td>
            }
            <td>
                <a asp-page="/Evenements/Historique" asp-route-idEvenement="@Model.IdEvenement" asp-route-nomJoueur="@item.Joueur">Details</a>
            </td>
        </tr>
		}
	</tbody>
</table>